package org.codehaus.mojo.scmchangelog;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on scmchangelog-maven-plugin.<br/> Call <pre>  mvn scmchangelog:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Tue Sep 22 16:49:50 CEST 2009
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.5)
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:scmchangelog-maven-plugin:1.3", 0 );
        append( sb, "", 0 );

        append( sb, "Maven SCM Changelog Reporter", 0 );
        append( sb, "Simple Reporter that creates a changelog report using comments and tags from the SCM.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 2 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "scmchangelog:help", 0 );
            append( sb, "Display help information on scmchangelog-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0scmchangelog:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "report".equals( goal ) )
        {
            append( sb, "scmchangelog:report", 0 );
            append( sb, "Goal which produces a changelog report based on the Subversion logs.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "basedir", 2 );
                append( sb, "The base directory.", 3 );
                append( sb, "", 0 );

                append( sb, "connectionType (Default: connection)", 2 );
                append( sb, "The type of connection to use (connection or developerConnection).", 3 );
                append( sb, "", 0 );

                append( sb, "connectionUrl (Default: ${project.scm.connection})", 2 );
                append( sb, "The SCM connection URL.", 3 );
                append( sb, "", 0 );

                append( sb, "dateFormat (Default: yyyy-MM-dd)", 2 );
                append( sb, "Used to specify the date format of the log entries that are retrieved from your SCM system.", 3 );
                append( sb, "", 0 );

                append( sb, "developerConnectionUrl (Default: ${project.scm.developerConnection})", 2 );
                append( sb, "The SCM connection URL for developers.", 3 );
                append( sb, "", 0 );

                append( sb, "filter", 2 );
                append( sb, "The regexp used to filter tags and branches names to produce the report.", 3 );
                append( sb, "", 0 );

                append( sb, "grammar (Default: MANU)", 2 );
                append( sb, "Grammar name for parsing svn logs", 3 );
                append( sb, "", 0 );

                append( sb, "passphrase", 2 );
                append( sb, "The passphrase (used by java svn).", 3 );
                append( sb, "", 0 );

                append( sb, "password", 2 );
                append( sb, "The user password (used by svn and starteam protocol).", 3 );
                append( sb, "", 0 );

                append( sb, "privateKey", 2 );
                append( sb, "The private key (used by java svn).", 3 );
                append( sb, "", 0 );

                append( sb, "releasesOrder (Default: historic)", 2 );
                append( sb, "Used to specify if the releases should be ordered alphabetally or historically. Supported values are historic and alphabetic.", 3 );
                append( sb, "", 0 );

                append( sb, "tagBase", 2 );
                append( sb, "The url of tags base directory (used by svn protocol).", 3 );
                append( sb, "", 0 );

                append( sb, "timestampFormat (Default: dd/MM/yyyy HH:mm)", 2 );
                append( sb, "Used to specify the date format of the log entries that are retrieved from your SCM system.", 3 );
                append( sb, "", 0 );

                append( sb, "trackerType (Default: ${project.issueManagement.system})", 2 );
                append( sb, "Used to specify the tracker type.", 3 );
                append( sb, "", 0 );

                append( sb, "trackerUrlPattern (Default: ${project.issueManagement.url})", 2 );
                append( sb, "Used to specify the tracker issue url pattern.", 3 );
                append( sb, "", 0 );

                append( sb, "username", 2 );
                append( sb, "The user name (used by svn and starteam protocol).", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
